# STM32CubeMonitor
## PACKAGE INSTALLATION & REBUILD OF DEPENDENCIES
Steps to generate a STM32CubeMonitor build based on electron

* Prerequisite : install inno setup
Inno setup must be installed with windows installer : http://www.jrsoftware.org/isdl.php#stable or 
V:\MMS_MCD_TOOLS\08_STM_Studio_CubeMonitor_Specific\5-Installations\inno setup\innosetup-5.6.1-unicode.exe

Please select the option "Install Inno Setup Preprocessor" during installation configuration.

Add the Inno compiler (ISCC.exe) path in the PATH environment variable

* Install the dependencies
```
 npm install
```
* rebuild natives modules to be compliant with electron.
In order to have a build setup operational, please read the following procedure : TBD
``` 
npm run build_dependencies ( =node ./node_modules/electron-rebuild/lib/src/cli.js --version=6.0.11)

```

* check everything is working
```
 npm run start
```
If everything is ok, close the application and do the next steps. If not , you can verify the flow, the dependencies, the rebuild.

## GENERATE THE INSTALLER FOR WINDOWS
* Deleting the following directories at root level( if existing )
```
 build/
 dist/
```

* build the .exe installer (could be really long)
```
 npm run build  
```

* the generated installer will be on 
```
 dist/SetupSTM32CubeMonitor.exe
```

## GENERATE THE INSTALLER FOR LINUX
* Deleting the following directories at root level( if existing )
```
 buildlinux/
 distlinux/
```

* build the .deb package (could be really long)
```
 yarn run buildlinux
```

* the generated debian package will be on
```
 distlinux/stm32cubemonitor_X.X.X_amd64.deb
```

## GENERATE THE INSTALLER FOR MACOS
* Deleting the following directories at root level( if existing )
```
 build/
 dist/
```

* build the disk image .dmg installer 
```
 npm run build_macos  
```

* the generated installer will be on 
```
 dist/SetupSTM32CubeMonitor-x.y.z.dmg
```

## MODIFYING THE TEMPLATE
It could be useful to update some items of STM32CubeMonitor tool or create a new tool based on this one.

### Default flow
* To change the default flow , modify the following file ```default/flows.json```
### Icons
* Icon for installer : ```installer.ico```
* Icon for installer & application (macOS) : ```default/ressources/icon.icns```
* Icon for Title (windows) : ```default/ressources/cubeMonitorTitleHigh.ico```
* Loading GIF : ```loading.gif```
* SplashScreen image : ```splash.bmp```
* Customization of Node-Red with ST flavour : ```default/settings.js```   (menu ```editorTheme```) 

### License
* License file for macOS (refer to https://www.electron.build/configuration/dmg for localisation): ```default/ressources/License_en.txt```

### Application name
* Installer Name: item ```setupExe``` in ```makewin64.js```
* Application Name: 
    - STM32CubeMonitor in script ```pack``` in ```package.json```
    - MyAppName and MyAppExeName to be changed in STM32CubeMonitor.iss

### Version
* Change the version in package.json. The package version is used for the installer

### Updating dependencies
* Adding specific application dependencies  in ```package.json```
    -   for example "node-red-contrib-stmstudio" already added for STM32CubeMonitor




